#include <sclib/image.h>

extern void* __VECTOR_TABLE;

struct ImageHeaderV4 image_hdr __attribute__((section(".image_hdr"))) = {
    .image_magic  = IMAGE_MAGIC,
    .header_start = (uint32_t*) &image_hdr,
    .vector_table = (uint32_t*) &__VECTOR_TABLE,
    .header_size  = sizeof(struct ImageHeaderV4),
    .image_end    = (uint32_t*) &__image_end,

    .image_hdr_version  = eHEADER_VERSION_4,
    .build              = {{ build_type }},
    .version            = {{ version | c_format }},
    .min_upgrade_from   = {{ min_upgrade_from | c_format }},
    .max_downgrade_from = {{ max_downgrade_from | c_format }},
    .target_hardware    = {{ hardware_max | c_format }},
    .min_hardware       = {{ hardware_min | c_format }},
    .time_utc           = {{ timestamp }}UL,
    .git_sha            = {{ git_sha | c_format }},
    .name               = {{ name | c_format }},

    .header_crc = 0x12344321,  // populated after linking
};
